unit NIST_Type_8_data_converter_main_form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, LCLType; //LCLType for HBitmap

type

  { TMainForm }

  TMainForm = class(TForm)
    ConvertFromType8Button: TButton;
    ConvertToType8Button: TButton;
    ComboBoxCompression: TComboBox;
    EditWidth: TEdit;
    EditHeight: TEdit;
    LabelWidth: TLabel;
    LabelHeight: TLabel;
    OpenButton: TButton;
    SaveButton: TButton;
    ScrollBox1: TScrollBox;
    WSQtoStreamButton: TButton;
    RegisterButton: TButton;
    StreamToWSQButton: TButton;
    OutputImage: TImage;
    procedure ConvertFromType8ButtonClick(Sender: TObject);
    procedure ConvertToType8ButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenButtonClick(Sender: TObject);
    procedure RegisterButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure StreamToWSQButtonClick(Sender: TObject);
    procedure WSQtoStreamButtonClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    bitmap : HBitmap;
    open_dialog : TOpenDialog;
    save_dialog : TSaveDialog;
  end; 

{ WSQ library declarations }
function RegisterWSQ():Integer; cdecl; external 'WSQ_library.dll' name '_RegisterWSQ';

//function GenerateSerialNumber():PAnsiChar; cdecl; external 'WSQ_library.dll' name '_GenerateSerialNumber';
//function UnlockWSQLibrary(const authorization_code: PAnsiChar):Integer; cdecl; external 'WSQ_library.dll' name '_UnlockWSQLibrary';

function CreateBMPFromFile (const file_name: PAnsiChar): HBitmap; cdecl; external 'WSQ_library.dll' name '_CreateBMPFromFile';
function SaveBMPToFile( const bitmap: HBITMAP;  const filename: PAnsiChar; filetype: Integer):Integer; cdecl; external 'WSQ_library.dll' name '_SaveBMPToFile';
function CreateBMPFromWSQByteArray (input_wsq_byte_array: PAnsiChar; const size_of_input_wsq_byte_array: Integer): HBitmap; cdecl; external 'WSQ_library.dll' name '_CreateBMPFromWSQByteArray';
function SaveWSQByteArrayToImageFile(input_wsq_byte_array: PAnsiChar; const size_of_input_wsq_byte_array: Integer;  const filename: PAnsiChar; filetype: Integer):Integer; cdecl; external 'WSQ_library.dll' name '_SaveWSQByteArrayToImageFile';
procedure SetShowFilePropertiesDialog(file_properties_dialog: Integer); cdecl; external 'WSQ_library.dll' name '_SetShowFilePropertiesDialog';
procedure ShowFileConverter(); cdecl; external 'WSQ_library.dll' name '_ShowFileConverter';
function WSQ_decode_stream( input_data_stream: PAnsiChar; const input_stream_length: Integer; output_data_stream: PPCHAR; width: PInteger; height: PInteger; ppi: PInteger; comment_text: PPCHAR):Integer; cdecl; external 'WSQ_library.dll' name '_WSQ_decode_stream';
function WSQ_encode_stream(input_data_stream: PAnsiChar; const width: Integer; const height: Integer; const bitrate:Double;
				   const ppi: Integer; comment_text: PAnsiChar; output_data_stream: PPCHAR; output_stream_length: PInteger):Integer; cdecl; external 'WSQ_library.dll' name '_WSQ_encode_stream';
function ConvertHBITMAPtoGrayScale256 (const bitmap: HBITMAP): HBitmap; cdecl; external 'WSQ_library.dll' name '_ConvertHBITMAPtoGrayScale256';
function SaveHBITMAPtoFileAsGrayScale256BMP(const bitmap: HBITMAP;  const filename: PAnsiChar):Integer; cdecl; external 'WSQ_library.dll' name '_SaveHBITMAPtoFileAsGrayScale256BMP';

function CreateHBITMAPfromNISTType8BinaryField(type8_width: Integer; type8_height: Integer; type8_compression_type: Integer; type8_input_byte_array: PAnsiChar; type8_input_byte_array_size: Integer): HBITMAP; cdecl; external 'WSQ_library.dll' name '_CreateHBITMAPfromNISTType8BinaryField';
//function CreateHBITMAPfromNISTType8UncompressedBinaryField(type8_width: Integer; type8_height: Integer; type8_input_byte_array: PAnsiChar; type8_input_byte_array_size: Integer): HBITMAP; cdecl; external 'WSQ_library.dll' name '_CreateHBITMAPfromNISTType8UncompressedBinaryField';
//function CreateHBITMAPfromNISTType8CompressedBinaryField(type8_width: Integer; type8_height: Integer; type8_input_byte_array: PAnsiChar; type8_input_byte_array_size: Integer): HBITMAP; cdecl; external 'WSQ_library.dll' name '_CreateHBITMAPfromNISTType8CompressedBinaryField';

function CreateNISTType8BinaryFieldfromHBITMAP(const input_HBITMAP: HBITMAP; type8_compression_type: Integer): PAnsiChar; cdecl; external 'WSQ_library.dll' name '_CreateNISTType8BinaryFieldfromHBITMAP';
//function CreateNISTType8UncompressedBinaryFieldfromHBITMAP(const input_HBITMAP: HBITMAP): PAnsiChar; cdecl; external 'WSQ_library.dll' name '_CreateNISTType8UncompressedBinaryFieldfromHBITMAP';
//function CreateNISTType8CompressedBinaryFieldfromHBITMAP(const input_HBITMAP: HBITMAP): PAnsiChar; cdecl; external 'WSQ_library.dll' name '_CreateNISTType8CompressedBinaryFieldfromHBITMAP';

function ReadType8DataCompressionType(): Integer; cdecl; external 'WSQ_library.dll' name '_ReadType8DataCompressionType';
function ReadType8DataWidth(): Integer; cdecl; external 'WSQ_library.dll' name '_ReadType8DataWidth';
function ReadType8DataHeight(): Integer; cdecl; external 'WSQ_library.dll' name '_ReadType8DataHeight';
function ReadSizeOfNISTType8BinaryField(): Integer; cdecl; external 'WSQ_library.dll' name '_ReadSizeOfNISTType8BinaryField';
function SetNISTType8ImageColorInversion(in_uncompressed_type8_image_inverted: Integer; out_uncompressed_type8_image_inverted: Integer; in_compressed_type8_image_inverted: Integer; out_compressed_type8_image_inverted: Integer): Integer; cdecl; external 'WSQ_library.dll' name '_SetNISTType8ImageColorInversion';



var
  MainForm: TMainForm;

   iFileHandle, iFileLength: Integer;
   input_data_stream, output_data_stream: PAnsiChar;
   input_data_stream2, output_data_stream2: PAnsiChar;
   image_width, image_height, ppi: Integer;
   bitrate: Double;
   comment_text: PAnsiChar;
   ret, n, input_stream_length: Integer;
   output_stream2_length: Integer;

   size_of_type8_binary_field: Integer;
   type8_image_width, type8_image_height: Integer;
   type8_image_compression_type: Integer;
   type8_image_size_txt_file: String;
   save_type8_binary_field_filename: String;

   txtf: TextFile;

   type8_input_data_stream, type8_output_data_stream: PAnsiChar;
   type8_input_stream_length, type8_output_stream_length: Integer;




implementation

{ TMainForm }




procedure TMainForm.FormCreate(Sender: TObject);
begin
       open_dialog := TOpenDialog.Create(MainForm);
       save_dialog := TSaveDialog.Create(MainForm);
       bitmap := HBitmap(nil);
       comment_text := PAnsiChar(nil); // It is important to initialize to NIL to avoid crashing

       ComboBoxCompression.Items.Add('Uncompressed');
       ComboBoxCompression.Items.Add('ANSI/EIA-538-1988 facsimile compression');
       ComboBoxCompression.ItemIndex := 0;

       EditWidth.Text := '0';
       EditHeight.Text := '0';

end;

procedure TMainForm.ConvertFromType8ButtonClick(Sender: TObject);
begin



       OpenButton.Enabled := false;
       SaveButton.Enabled := false;
       ConvertFromType8Button.Enabled := false;
       ConvertToType8Button.Enabled := false;


       	type8_image_width := 0;
       	type8_image_height := 0;
       	type8_image_compression_type := 0;

           open_dialog.Filter := 'Binary files|*.bin';
       //    open_dialog.Filter := 'All files|*.*';
       	if ( open_dialog.Execute() ) then
         begin


          iFileHandle := FileOpen(open_dialog.FileName, fmOpenRead);
          iFileLength := FileSeek(iFileHandle,0,2);
          FileSeek(iFileHandle,0,0);
          type8_input_data_stream := PAnsiChar(AllocMem(iFileLength + 1));
          type8_input_stream_length := FileRead(iFileHandle, type8_input_data_stream^, iFileLength);
          FileClose(iFileHandle);


          type8_image_size_txt_file := ChangeFileExt(open_dialog.FileName, '.txt');

          if(FileExists(type8_image_size_txt_file)) then
          begin

          AssignFile(txtf, type8_image_size_txt_file);

          try
            try
             Reset(txtf);
             //Warning: fails to read UTF-8 txt file
             readLn(txtf, type8_image_compression_type);
             readLn(txtf, type8_image_width);
             readLn(txtf, type8_image_height);
            except
              ShowMessage('Error reading file:' + #13#10 + type8_image_size_txt_file);
            end;
          finally
             CloseFile(txtf);
          end;

            EditWidth.Text := IntToStr(type8_image_width);
            EditHeight.Text := IntToStr(type8_image_height);
            ComboBoxCompression.ItemIndex := type8_image_compression_type;

          end //if(FileExists(type8_image_size_txt_file))
          else
          begin
            type8_image_width := StrToIntDef(EditWidth.Text, 0);
            type8_image_height := StrToIntDef(EditHeight.Text, 0);
            type8_image_compression_type := ComboBoxCompression.ItemIndex;
          end;//if(FileExists(type8_image_size_txt_file)) then


          if((type8_image_width = 0) or (type8_image_height = 0)) then
          begin
          Application.MessageBox( 'You must manually set the type8_width and type8_height and compression type of the image.', 'Warning', MB_OK );
          ConvertFromType8Button.Enabled := true;
          OpenButton.Enabled := true;
          exit;
          end;


       // Take and use Handle of HBitmap directly from WSQ image library DLL.
       // If the WSQ image library is called to load or save another picture, you will lose the current image

              OutputImage.Picture.Bitmap.Handle := CreateHBITMAPfromNISTType8BinaryField(type8_image_width, type8_image_height, type8_image_compression_type, type8_input_data_stream, type8_input_stream_length);

       //       if(type8_image_compression_type = 0) then
       //       OutputImage.Picture.Bitmap.Handle := CreateHBITMAPfromNISTType8UncompressedBinaryField(type8_image_width, type8_image_height, type8_input_data_stream, type8_input_stream_length)
       //      else
       //      OutputImage.Picture.Bitmap.Handle := CreateHBITMAPfromNISTType8CompressedBinaryField(type8_image_width, type8_image_height, type8_input_data_stream, type8_input_stream_length);

               if ( OutputImage.Picture.Bitmap.Handle <> HBitmap(NIL)) then
               begin
                  SaveButton.Enabled := True;
                  ConvertToType8Button.Enabled := True;
                  OutputImage.Height := OutputImage.Picture.Bitmap.Height;
                  OutputImage.Width := OutputImage.Picture.Bitmap.Width;
                  Invalidate;
               end
               else
               begin
                   Application.MessageBox(PCHAR('Unable to load file'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
               end;


       	end;//if ( open_dialog.Execute() )



         OpenButton.Enabled := true;
         SaveButton.Enabled := true;
         ConvertFromType8Button.Enabled := true;
         ConvertToType8Button.Enabled := true;

end;

procedure TMainForm.ConvertToType8ButtonClick(Sender: TObject);
begin


          save_dialog.Filter := 'BIN Files (*.bin)|*.bin';
          save_dialog.DefaultExt := 'bin';

         if save_dialog.Execute() then
         begin



          OpenButton.Enabled := false;
          SaveButton.Enabled := false;
          ConvertFromType8Button.Enabled := false;
          ConvertToType8Button.Enabled := false;



        	type8_image_width := OutputImage.Picture.Bitmap.Width;
        	type8_image_height := OutputImage.Picture.Bitmap.Height;

        	EditWidth.Text := IntToStr(type8_image_width);
        	EditHeight.Text := IntToStr(type8_image_height);

        	type8_image_compression_type := ComboBoxCompression.ItemIndex;

          type8_image_size_txt_file := ChangeFileExt(save_dialog.FileName, '.txt');


          with TStringList.Create do
            try
               Add(IntToStr(type8_image_compression_type));
               Add(IntToStr(type8_image_width));
               Add(IntToStr(type8_image_height));
               SaveToFile(type8_image_size_txt_file);
            finally
              Free;
            end;


        	 type8_output_data_stream := CreateNISTType8BinaryFieldfromHBITMAP(OutputImage.Picture.Bitmap.Handle, type8_image_compression_type);

         //  if(type8_image_compression_type = 0) then
         //	 type8_output_data_stream := CreateNISTType8UncompressedBinaryFieldfromHBITMAP(OutputImage.Picture.Bitmap.Handle)
         //  else
         //	 type8_output_data_stream := CreateNISTType8CompressedBinaryFieldfromHBITMAP(OutputImage.Picture.Bitmap.Handle);


        	 type8_output_stream_length := ReadSizeOfNISTType8BinaryField();


        	save_type8_binary_field_filename := ChangeFileExt(save_dialog.FileName, '.bin');


          iFileHandle := FileCreate(PCHAR(save_type8_binary_field_filename));
          FileWrite(iFileHandle, type8_output_data_stream^, type8_output_stream_length);
          FileClose(iFileHandle);


        	ShowMessage('The converted file was saved as:' + #13#10 + save_type8_binary_field_filename);


          OpenButton.Enabled := true;
          SaveButton.Enabled := true;
          ConvertFromType8Button.Enabled := true;
          ConvertToType8Button.Enabled := true;


         end; //if save_dialog.Execute() then

end;


procedure TMainForm.FormDestroy(Sender: TObject);
begin
        open_dialog.Destroy;
        save_dialog.Destroy;
end;

procedure TMainForm.OpenButtonClick(Sender: TObject);
begin


    open_dialog.Filter := 'All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;*.emf;' +
    '*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;*.rgba;*.rgb;' +
    '*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp;|FBI Wavelet Scalar Quantization (*.wsq)|*.wsq|' +
    'Windows bitmaps (*.bmp)|*.bmp|Macintosh TIFF images (*.tiff)|*.tiff|PC TIFF images (*.tif)|*.tif|JPG images (*.jpg)|*.jpg|' +
    'JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc|' +
    'JPE images (*.jpe)|*.jpe|JPEG images (*.jpeg)|*.jpeg|Portable network graphic images (*.png)|*.png|' +
    'Compuserve Graphic Interchange Format(*.gif)|*gif|Paintshop Pro images (*.psp)|*.psp|JFIF images (*.jfif)|*.jfif|' +
    'Run length encoded Windows bitmaps (*.rle)|*.rle|Device independant Windows bitmaps (*.dib)|*.dib|Truevision images (*.win)|*.win|' +
    'Truevision images (*.vst)|*.vst|Truevision images (*.vda)|*.vda|Truevision images (*.tga)|*.tga|Truevision images (*.icb)|*.icb|' +
    'GFI fax images (*.fax)|*.fax|Encapsulated Postscript images (*.eps)|*.eps|ZSoft Paintbrush images (*.pcx)|*.pcx|' +
    'ZSoft Paintbrush images (*.pcc)|*.pcc|Word 5.x screen capture images (*.scr)|*.scr|Alias/Wavefront images (*.rpf)|*.rpf|' +
    'Alias/Wavefront images (*.rla)|*.rla|SGI true color images (*.sgi)|*.sgi|SGI true color images with alpha (*.rgba)|*.rgba|' +
    'SGI true color images (*.rgb)|*.rgb|SGI black/white images (*.bw)|*.bw|Photoshop images (*.psd)|*.psd|Photoshop images (*.pdd)|*.pdd|' +
    'Portable pixel map images (*.ppm)|*.ppm|Portable gray map images (*.pgm)|*.pgm|Portable bitmap images (*.pbm)|*.pbm|' +
    'Autodesk images (*.cel)|*.cel|Autodesk images (*.pic)|*.pic|Kodak Photo-CD images (*.pcd)|*.pcd|Dr. Halo images (*.cut)|*.cut|' +
    'Amiga Bitmap Graphic (8 bits)|*.iff|Windows icons (*.ico)|*.ico|Windows metafiles (*.wmf)|*.wmf|Windows enhanced meta files (*.emf)|*.emf';



if open_dialog.Execute() then
begin


// Take and use Handle of HBitmap directly from WSQ image library DLL.
// If the WSQ image library is called to load or save another picture, you will lose the current image
       OutputImage.Picture.Bitmap.Handle := CreateBMPFromFile( PAnsiChar(open_dialog.FileName));

        if ( OutputImage.Picture.Bitmap.Handle <> HBitmap(NIL)) then
        begin
           SaveButton.Enabled := True;
           OutputImage.Height := OutputImage.Picture.Bitmap.Height;
           OutputImage.Width := OutputImage.Picture.Bitmap.Width;
           Invalidate;
        end
        else
        begin
            Application.MessageBox(PCHAR('Unable to load file'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;


{
//Make a copy of HBitmap into OutputImage->Picture

     bitmap := CreateBMPFromFile( PCHAR(open_dialog.FileName));

        if ( bitmap <> HBitmap(NIL)) then
        begin
           SaveButton.Enabled := True;
           OutputImage.Picture.Bitmap.Handle  := HBitmap(CopyImage(bitmap, IMAGE_BITMAP, 0, 0,LR_COPYRETURNORG));
           OutputImage.Height := OutputImage.Picture.Bitmap.Height;
           OutputImage.Width := OutputImage.Picture.Bitmap.Width;
           Invalidate;
        end
        else
        begin
            Application.MessageBox(PCHAR('Unable to load file'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;
}



end;


end;

procedure TMainForm.RegisterButtonClick(Sender: TObject);
begin

RegisterWSQ();

end;

procedure TMainForm.SaveButtonClick(Sender: TObject);
begin


    save_dialog.Filter := 'WSQ Files (*.wsq)|*.wsq|Windows BMP (*.bmp)|*.bmp|TIFF Files (*.tif)|*.tif|PNG Files (*.png)|*.png|' +
    'JPEG Files (*.jpg)|*.jpg|Targa Files (*.tga)|*.tga|SGI Files (*.rgb)|*.rgb|JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc';
    save_dialog.DefaultExt := 'wsq';


if save_dialog.Execute() then
begin

       SetShowFilePropertiesDialog(1);
       SaveBMPToFile( OutputImage.Picture.Bitmap.Handle, PAnsiChar(save_dialog.FileName), save_dialog.FilterIndex);

end;


end;

procedure TMainForm.StreamToWSQButtonClick(Sender: TObject);
var
    x, y, row, row2, pixel_number, pixel_number2: Integer;
begin

   save_dialog.Filter := 'WSQ Files (*.wsq)|*.wsq';
    save_dialog.DefaultExt := 'wsq';

if save_dialog.Execute() then
begin
    bitrate := 0.75;
    ppi := 500;
//    comment_text := nil;
    comment_text := 'Cognaxon';

    if(input_data_stream2 <> PAnsiChar(nil)) then
    begin
    FreeMem(input_data_stream2); input_data_stream2 := PAnsiChar(nil);
    end;

    input_data_stream2 := PAnsiChar(AllocMem(image_width*image_height));


	// MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
    for y := 0 to (image_height - 1) do
    begin
      row := image_width * y;
      row2 := image_width * (image_height - y - 1);

        for x := 0 to (image_width - 1) do
        begin
         pixel_number := row + x;
         pixel_number2 := row2 + (image_width - x - 1);

         input_data_stream2[pixel_number2] := output_data_stream[pixel_number];
        end;
    end;




// THE ENCODING OF DECOMPRESSED STREAM INTO WSQ STREAM
WSQ_encode_stream(input_data_stream2, image_width, image_height, bitrate, ppi, PAnsiChar(comment_text), @output_data_stream2, @output_stream2_length);

    comment_text := PAnsiChar(nil); // It is important to initialize to NIL to avoid crashing

    iFileHandle := FileCreate(save_dialog.FileName);
    FileWrite(iFileHandle, output_data_stream2^, output_stream2_length);
    FileClose(iFileHandle);

Application.MessageBox(PCHAR('Memory stream was compressed into another memory stream and saved to WSQ file.' + #13#10 + 'Now please press button "Open", select the saved file, open it and have a look at the' + #13#10 + 'results of memory stream processing. The processed image is mirrored/flipped' + #13#10 + '(UP<->DOWN and LEFT<->RIGHT).'), PCHAR('WSQ image library'), MB_OK );

end;


end;

procedure TMainForm.WSQtoStreamButtonClick(Sender: TObject);
var
  iFileLength: Integer;
begin


    open_dialog.Filter := 'FBI Wavelet Scalar Quantization (*.wsq)|*.wsq';


if open_dialog.Execute() then
begin

      iFileHandle := FileOpen(open_dialog.FileName, fmOpenRead);
      iFileLength := FileSeek(iFileHandle,0,2);
      FileSeek(iFileHandle,0,0);
      input_data_stream := PAnsiChar(AllocMem(iFileLength + 1));
      input_stream_length := FileRead(iFileHandle, input_data_stream^, iFileLength);
      FileClose(iFileHandle);


// THE DECODING OF WSQ STREAM INTO DECOMPRESSED STREAM
WSQ_decode_stream(input_data_stream, input_stream_length, @output_data_stream, @image_width, @image_height, @ppi, @comment_text);


//Converts WSQ compressed byte array into HBITMAP for showing on screen
       OutputImage.Picture.Bitmap.Handle := CreateBMPFromWSQByteArray(input_data_stream, input_stream_length);
// Saves WSQ compressed byte array to an image file.
       //SaveWSQByteArrayToImageFile(input_data_stream, input_stream_length, PAnsiChar('C:\OutputDirectory\output.jpg'), 5);


        if ( OutputImage.Picture.Bitmap.Handle <> HBitmap(NIL)) then
        begin
           SaveButton.Enabled := True;
           OutputImage.Height := OutputImage.Picture.Bitmap.Height;
           OutputImage.Width := OutputImage.Picture.Bitmap.Width;
           Invalidate;
           Application.MessageBox(PCHAR('WSQ file was loaded into memory stream and decompressed into another memory stream.' + #13#10 + 'Now please press button "stream -> WSQ" to compress memory stream and save it to file.' + #13#10 + 'WSQ compressed byte array was converted to HBITMAP for showing on screen.'), PCHAR('WSQ image library'), MB_OK );
        end
        else
        begin
            Application.MessageBox(PCHAR('Error: unable to decompress WSQ byte array.'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;


       StreamToWSQButton.Enabled := True;
end;


end;

initialization
  {$I nist_type_8_data_converter_main_form.lrs}

end.

